/* $Id: visual.c,v 1.5 1998/10/18 15:52:26 becka Exp $
***************************************************************************

  Linear 2 bit graphics (high-pair-left)

  Copyright (C) 1998 Andrew Apted  [andrew@ggi-project.org]

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
*/

#include <stdlib.h>

#include <ggi/internal/ggi-dl.h>


int GGIdlinit(ggi_visual *vis, const char *version,void *argptr)
{
	/* Frame handling
	 */

	vis->opdraw->setreadframe=GGI_default_setreadframe;
	vis->opdraw->setwriteframe=GGI_default_setwriteframe;
	
	/* Drawing ops
	 */
	vis->opdraw->putpixel_nc=GGIputpixel_nc;
	vis->opdraw->getpixel=GGIgetpixel;

	/* Not yet implemented:
	 *	drawpixel_nc, drawpixel, putpixel,
	 *	drawhline_nc, drawvline_nc,
	 *	putc, getcharsize,
	 *	puthline, putvline,
	 *	gethline, getvline.
	 */

	/* Left to generic-color:
	 *    mapcolor, unmappixel,
	 *    packcolors, unpackpixels.
	 */

	/* Left to generic-stubs:
	 *    drawhline, drawvline, drawline,
	 *    puts, copybox, crossblit.
	 */

	return GGI_DL_OPDRAW;
}

int GGIdlcleanup(ggi_visual *vis)
{
	return 0;
}
		
#include <ggi/internal/ggidlinit.h>
