/* $Id: multi_defs.h,v 1.6 1998/09/23 21:38:13 marcus Exp $
***************************************************************************

   Display-multi: definitions

   Copyright (C) 1998 Andrew Apted    [andrew@ggi-project.org]

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
*/

#ifndef _DISPLAY_MULTI_H
#define _DISPLAY_MULTI_H

#include <ggi/internal/ggi-dl.h>

ggifunc_getmode		GGI_multi_getmode;
ggifunc_setmode		GGI_multi_setmode;
ggifunc_checkmode	GGI_multi_checkmode;
ggifunc_flush		GGI_multi_flush;
ggifunc_setflags	GGI_multi_setflags;

ggifunc_eventpoll	GGI_multi_eventpoll;
ggifunc_eventread	GGI_multi_eventread;

ggifunc_gcchanged	GGI_multi_gcchanged;

ggifunc_fillscreen	GGI_multi_fillscreen;
ggifunc_setorigin	GGI_multi_setorigin;

ggifunc_putc		GGI_multi_putc;
ggifunc_puts		GGI_multi_puts;
ggifunc_getcharsize	GGI_multi_getcharsize;

ggifunc_drawpixel_nc	GGI_multi_drawpixel;
ggifunc_drawpixel	GGI_multi_drawpixel;
ggifunc_putpixel_nc	GGI_multi_putpixel;
ggifunc_putpixel	GGI_multi_putpixel;
ggifunc_getpixel	GGI_multi_getpixel;

ggifunc_drawline	GGI_multi_drawline;
ggifunc_drawhline	GGI_multi_drawhline;
ggifunc_puthline	GGI_multi_puthline;
ggifunc_gethline	GGI_multi_gethline;

ggifunc_drawvline	GGI_multi_drawvline;
ggifunc_putvline	GGI_multi_putvline;
ggifunc_getvline	GGI_multi_getvline;

ggifunc_drawbox		GGI_multi_drawbox;
ggifunc_putbox		GGI_multi_putbox;
ggifunc_getbox		GGI_multi_getbox;
ggifunc_copybox		GGI_multi_copybox;

ggifunc_getgamma	GGI_multi_getgamma;
ggifunc_setgamma	GGI_multi_setgamma;
ggifunc_getgammamap	GGI_multi_getgammamap;
ggifunc_setgammamap	GGI_multi_setgammamap;

ggifunc_mapcolor	GGI_multi_mapcolor;
ggifunc_unmappixel	GGI_multi_unmappixel;
ggifunc_setpalvec	GGI_multi_setpalvec;
ggifunc_getpalvec	GGI_multi_getpalvec;

typedef struct multi_vis
{
	struct multi_vis *next;

	ggi_visual *vis;

	/* ... visual-specific info here */

} MultiVis;

typedef struct multi_hook
{
	int vis_num;

	MultiVis *vis_list;

	/* ... global info here */

} MultiHook;


#endif /* _DISPLAY_MULTI_H */
