#ifndef _threads_h_
#define _threads_h_

#ifdef USE_THREADS
#  include <pthread.h>
   typedef pthread_mutex_t ggi_mutex;
#  define _ggiLockInit(x) (pthread_mutex_init(&(x)->mutex,NULL))
#  define _ggiLock(x)	(pthread_mutex_lock(&(x)->mutex))
#  define _ggiUnlock(x)	(pthread_mutex_unlock(&(x)->mutex))
#  define _ggiLockDestroy(x) (pthread_mutex_destroy(&(x)->mutex))
#else
   typedef void * ggi_mutex;
#  define _ggiLockInit(x)
#  define _ggiLock(x)
#  define _ggiUnlock(x)
#  define _ggiLockDestroy(x)
#endif /* USE_THREADS */

#endif /* _threads_h_ */
