/* 
 *  API stubs
 *
 *  Copyright (C) 1998 Thomas Tanner. See CREDITS for details.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "internal3d.h"

/*----------------------------------------------------------------------*/

/* drawing functions */

#define	CALL(vis,f)	\
	_ggiLock(vis->mutex);\
	GGI3D_FUNC(vis)->f;\
	_ggiUnlock(vis->mutex);\
        return 0;

int ggi3DDrawTriangle(ggi_visual_t vis, 
		      ggi_float x1, ggi_float y1, ggi_float z1,
		      ggi_float x2, ggi_float y2, ggi_float z2,
		      ggi_float x3, ggi_float y3, ggi_float z3)
{
	CALL(vis, triangle(vis, x1, y1, z1, x2, y2, z2, x3, y3, z3))
}
